//    2004-2012
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <math.h>
#include "Vector.h"
#define max(a, b)  (((a) > (b)) ? (a) : (b))
#define max3(a, b, c)  (((max(a,b)) > (c)) ? (max(a,b)) : (c))


//---------------------------------------------------------------------------
#pragma package(smart_init)
int OsFinding(vector a,vector b,vector c,double &alfa, vector &Os)
{//     (alfa -        Os -   )
double x,y,z,a1,a2,a3,b1,b2,b3,c1,c2,c3,d1,d2,d3,tmp;
//   
//   a1 a2 a3 | d1 * alfa
//   b1 b2 b3 | d2 * alfa
//   c1 c2 c3 | d3 * alfa
a1=a[0];a2=a[1];a3=a[2];b1=b[0];b2=b[1];b3=b[2];c1=c[0];c2=c[1];c3=c[2];
d1=d2=d3=1;
//   
tmp=sqrt(a1*a1+a2*a2+a3*a3);a1/=tmp;a2/=tmp;a3/=tmp;
tmp=sqrt(b1*b1+b2*b2+b3*b3);b1/=tmp;b2/=tmp;b3/=tmp;
tmp=sqrt(c1*c1+c2*c2+c3*c3);c1/=tmp;c2/=tmp;c3/=tmp;
//        
if (a1==0)
   if (b1!=0){tmp=a1;a1=b1;b1=tmp;tmp=a2;a2=b2;b2=tmp;tmp=a3;a3=b3;b3=tmp;}  // 1-  2- 
   else {if (b1!=0){tmp=a1;a1=c1;c1=tmp;tmp=a2;a2=c2;c2=tmp;tmp=a3;a3=c3;c3=tmp;}// 1-  3- 
         else {Application->MessageBox("    -   "," ",MB_ICONERROR);return -1;}}
//    
a2/=a1;a3/=a1;d1/=a1;a1=1;
if (b1!=0) {b2/=b1;b3/=b1;d2/=b1;b1=1;}
if (c1!=0) {c2/=c1;c3/=c1;d3/=c1;c1=1;}
//  (    2-  3- )
if (b1!=0) {b1-=a1;b2-=a2;b3-=a3;d2-=d1;}
if (c1!=0) {c1-=a1;c2-=a2;c3-=a3;d3-=d1;}
//        
if (b2==0)
  if (c2!=0) {tmp=b2;b2=c2;c2=tmp;tmp=b3;b3=c3;c3=tmp;tmp=d2;d2=d3;d3=tmp;}
  else {Application->MessageBox("    -   "," ",MB_ICONERROR);return -1;}
//    
d2/=b2;b3/=b2;b2=1;if (c2!=0){d3/=c2;c3/=c2;c2=1;}
//  (    3- )
if (c2!=0) {c2-=b2;c3-=b3;d3-=d2;};
if (c3!=0) {d3/=c3;c3=1;} else {Application->MessageBox("    -   "," ",MB_ICONERROR);return -1;}
//      1-  2- 
d1=d1-a3*d3;a3=a3-a3*c3;
d2=d2-b3*d3;b3=b3-b3*c3;
//      2- 
d1=d1-a2*d2;a2=a2-a2*b2;
//  
tmp=sqrt(d1*d1+d2*d2+d3*d3);
tmp=1/tmp; //       ( )
alfa=acos(tmp);//  
x=d1*tmp;y=d2*tmp;z=d3*tmp;
Os[0]=x;Os[1]=y;Os[2]=z;
return 1;
}
//---------------------------------------------------------------------------
AnsiString VidGradStrOfRad(double alfa)
{//       xxxxx'xx"
AnsiString tmp;
alfa=alfa*180/3.14159265358979+0.0001454441043328606481;//  
if (alfa<0) {alfa=-alfa; tmp="-";} else tmp="";
int i=alfa;// 
tmp+=IntToStr(i)+"";
alfa=(alfa-i)*60; i=alfa;// 
tmp+=IntToStr(i)+"'";
alfa=(alfa-i)*60; i=alfa;// 
tmp+=IntToStr(i)+'"';
return tmp;
}
//---------------------------------------------------------------------------
AnsiString VidGradMinStrOfRad(double alfa)
{//       xxxxx'xx"
AnsiString tmp;                
alfa=alfa*180/3.14159265358979+0.008726646259971639;//  
if (alfa<0) {alfa=-alfa; tmp="-";} else tmp="";
int i=alfa;// 
tmp+=IntToStr(i)+"";
alfa=(alfa-i)*60; i=alfa;// 
tmp+=IntToStr(i)+"'";
return tmp;
}
//---------------------------------------------------------------------------
double CornerBetweenVectors(vector a,vector b)
{ //   
double tmp,a0,a1,a2,b0,b1,b2;
//   
tmp=sqrt(a[0]*a[0]+a[1]*a[1]+a[2]*a[2]); if (tmp==0) return 0;
a0=a[0]/tmp;a1=a[1]/tmp;a2=a[2]/tmp;
tmp=sqrt(b[0]*b[0]+b[1]*b[1]+b[2]*b[2]); if (tmp==0) return 0;
b0=b[0]/tmp;b1=b[1]/tmp;b2=b[2]/tmp;
//  
tmp=a0*b0+a1*b1+a2*b2;
if (tmp>=1)return 0; if (tmp<=-1) tmp=-1;
tmp=acos(tmp);//  
return tmp;
}
//---------------------------------------------------------------------------
double SharpCorner(double m)
{//      
if (fabs(m)>200) m=acos(cos(m));
if (m>0) while (m>3.14159265358979) m-=3.14159265358979;
if (m<0) while (m<0) m+=3.14159265358979;
if (m>(3.14159265358979/2))m=3.14159265358979-m;
return m;
}
//---------------------------------------------------------------------------
void PloskostNormalPoint(vector a, tochka t, ploskost &p)
{//       
p[0]=a[0];p[1]=a[1];p[2]=a[2];
p[3]=-a[0]*t[0]-a[1]*t[1]-a[2]*t[2];
}
//---------------------------------------------------------------------------
bool ProekciaVector(ploskost p, vector a, vector &b)
{//b -  a   p
double tmp=p[0]*a[0]+p[1]*a[1]+p[2]*a[2];
if (tmp==0) {b[0]=0;b[1]=0;b[2]=0;return false;}
tmp=tmp/(p[0]*p[0]+p[1]*p[1]+p[2]*p[2]);
b[0]=a[0]-p[0]*tmp;b[1]=a[1]-p[1]*tmp;b[2]=a[2]-p[2]*tmp;
return true;
}
//---------------------------------------------------------------------------
bool TockaUnderPloskost(ploskost p,tochka t)
{//    (    - 
                                                     // . )
if (((2*(p[0]*p[0]+p[1]*p[1]+p[2]*p[2])+p[3])*(p[0]*t[0]+p[1]*t[1]+p[2]*t[2]+p[3]))>0) return true;
else return false;
}
//---------------------------------------------------------------------------
bool VectorProduct(vector a, vector b, vector &c)
{// 
c[0]=a[1]*b[2]-a[2]*b[1];
c[1]=a[2]*b[0]-a[0]*b[2];
c[2]=a[0]*b[1]-a[1]*b[0];
return true;
}
//---------------------------------------------------------------------------
void Norma1(vector a)
{//     
double t=sqrt(a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);
if (t==0) return;
a[0]=a[0]/t;a[1]=a[1]/t;a[2]=a[2]/t;
}
//---------------------------------------------------------------------------
bool VectorPloskostCornerVector1(const vector m, const vector pl, const double a, vector &b, vector &bb)
{//  b       pl    a   m
double a1,b1,c1,d1,a2,b2,c2,d2,a3,b3,c3,d3,x,y,z,tmp;
//   
a3=b3=c3=d3=1;
b[0]=bb[0]=0; b[1]=bb[1]=0; b[2]=bb[2]=0;//     
tmp=sqrt(m[0]*m[0]+m[1]*m[1]+m[2]*m[2]);
if (tmp==0) return false;
a1=m[0]/tmp; b1=m[1]/tmp; c1=m[2]/tmp; d1=cos(a);
tmp=sqrt(pl[0]*pl[0]+pl[1]*pl[1]+pl[2]*pl[2]);
if (tmp==0) return false;
vector m_, pl_; m_[0]=m[0];m_[1]=m[1];m_[2]=m[2]; pl_[0]=pl[0];pl_[1]=pl[1];pl_[2]=pl[2];
double dopugol=1.5707963267948966192313216916398-SharpCorner(CornerBetweenVectors(m_,pl_));
//if (dopugol<0.00000000000001) return VectorPloskostCornerVector90(m,pl,a,b,bb);
dopugol+=a;
double perpendic=m[0]*pl[0]+m[1]*pl[1]+m[2]*pl[2];
//if (dopugol<0) tmp=-tmp;//    m  pl    a  90
     // pl -    (     )
a2=pl[0]/tmp; b2=pl[1]/tmp; c2=pl[2]/tmp; d2=0;
//       
if (((a1==a2)&&(b1==b2)&&(c1==c2))||((a1==-a2)&&(b1==-b2)&&(c1==-c2))) return false;
if (a1==0) {tmp=a1; a1=a2; a2=tmp; tmp=b1; b1=b2; b2=tmp;
            tmp=c1; c1=c2; c2=tmp; tmp=d1; d1=d2; d2=tmp;}
if (a1==0)//    x      2 
        {
        if (b1==0) {tmp=b1; b1=b2; b2=tmp; tmp=c1; c1=c2; c2=tmp; tmp=d1; d1=d2; d2=tmp;}
        if (b1==0)//  x  y  
                { 
                if (c2==0) {if (c1!=0) {z=d1/c1;
                                       if ((z==1)||(z==-1)){b[2]=bb[2]=z;return true;}
                                       else return false;}
                            else return false;}
                }
        d1=d1/b1;c1=c1/b1;b1=1; d2=d2/b2;c2=c2/b2;b2=1;
        d2=d2-d1;c2=c2-c1;b2=b2-b1;
        if (c2==0) return false;
        d2=d2/c2; z=d2; d1=d1-d2*c1; y=d1;tmp=1-(z*z)-(y*y);
        if (tmp<1) return false;
        x=sqrt(tmp);
        b[0]=x;bb[0]=-x; b[1]=bb[1]=y; b[2]=bb[2]=z;
        return true;
        }
d1=d1/a1;c1=c1/a1;b1=b1/a1;a1=1;
if (a2!=0) {d2=d2/a2-d1;c2=c2/a2-c1;b2=b2/a2-b1;a2=0;};
if (b2==0)
        {// ?
         if (c2!=0)//   z
                   {bb[2]=b[2]=z=d2/c2;
                   d1=d1-c1*z;
                   d3=1-z*z;
                   a3=2;b3=-(b1*d1);c3=d1*d1-d3;
                   tmp=b3*b3-a3*c3;
                   if (tmp<0) {b[0]=bb[0]=0; b[1]=bb[1]=0; return false;}
                   b[1]=(-b3+sqrt(tmp))/a3;bb[1]=(-b3-sqrt(tmp))/a3;
                   b[0]=d1-(b1*b[1]); bb[0]=d1-(b1*bb[1]);
                   return true;}
         else return false;
         //ShowMessage("  ");
        }
d2=d2/b2;c2=c2/b2;b2=1;
d1=d1-(d2*b1);c1=c1-(c2*b1);b1=0;
a3=(c1*c1)+(c2*c2)+1;  b3=-(c1*d1)-(c2*d2);  c3=(d1*d1)+(d2*d2)-1;
d3=(b3*b3)-(a3*c3);
if (d3<0){if (d3>-0.000000000001) d3=0; else {
ShowMessage("   .\n\n   : "+FloatToStr(d3)+
+".\n \"Vector.cpp\",  \"VectorPloskostCornerVector1\"."+
"\n\n   -   90 ="+VidGradStrOfRad(dopugol)+"="+FloatToStr(dopugol)+" "+
"\n\n     ="+FloatToStr(perpendic)+
"\n    "+FloatToStr(dopugol+a)+" "
); return false;
}};
d3=sqrt(d3);
b[2]=z=(-b3-d3)/a3;b[0]=x=d1-(c1*z);b[1]=y=d2-(c2*z);
bb[2]=z=(-b3+d3)/a3;bb[0]=x=d1-(c1*z);bb[1]=y=d2-(c2*z);
return true;
}
//---------------------------------------------------------------------------
bool VectorPloskostCornerVector90(const vector m, const vector pl, const double a, vector &b, vector &bb)
{//  b       pl    a   m
//  m  pl 
vector m_, pl_; m_[0]=m[0];m_[1]=m[1];m_[2]=m[2]; pl_[0]=pl[0];pl_[1]=pl[1];pl_[2]=pl[2];
Norma1(m_);Norma1(pl_);
double a1=m_[0],a2=pl_[0],b1=m_[1],b2=pl_[1],c1=m_[2],c2=pl_[2],d1=a,d2=0,x,y,z;
if ((a1==0)&&(a2==0))
   {//         b1*y+c1*z=d1  b2*y+c2*z=0
    double opred2=(b1*c2)-(b2*c1);
    if (opred2==0) {ShowMessage("   .\n\n  0\n \"Vector.cpp\",  \"VectorPloskostCornerVector90\".");return false;}
    else {
       y=(b1*c2)/opred2; z=-(b2*c1)/opred2;x=sqrt(1-y*y-z*z);
       b[0]=x; bb[0]=-x; b[1]=bb[1]=y; b[2]=bb[2]=z; return true;}
   }
else {//  a1*x+b1*y+c1*z=d1  a2*x+b2*y+c2*z=0
   if (a1==0) //  a2!=0    //  
       {double tmp; tmp=a1;a1=a2;a2=tmp;tmp=b1;b1=b2;b2=tmp;tmp=c1;c1=c2;c2=tmp;
       tmp=d1;d1=d2;d2=tmp; }
   d1/=a1;c1/=a1;b1/=a1;a1=1;
   d2=d2-(d1*a2); c2=c2-(c1*a2); b2=b2-(b1*a2);  a2=0;
   if (b2!=0)
       {d2/=b2; c2/=b2; b2=1;
        d1=d1-(d2*b1); c1=c1-(c2*b1); b1=0;
        //    x+c1*z=d1   y+c2*z=d2 => (c1*z-d1)^2+(c2*z-d2)^2+z^2=1  =>
        //(c1*c1+c2*c2+1)*z*z-2*(c1*d1+c2*d2)*z+(d1*d1+d2*d2-1)=0
        double a=c1*c1+c2*c2+1, k=c1*d1+c2*d2, c=d1*d1+d2*d2-1, d=k*k-a*c;
        if (d<0) {
        ShowMessage("   .\n\n    "
        +FloatToStr(d)+
        +"\n \"Vector.cpp\",  \"VectorPloskostCornerVector90\".\n");return false;}
        d=sqrt(d); b[2]=(k-d)/a; b[1]=d2-(c2*b[2]); b[0]=d1-(c1*b[2]);
        bb[2]=(k+d)/a; bb[1]=d2-(c2*bb[2]); bb[0]=d1-(c1*bb[2]);
       }
   else {
        if (c2==0){ShowMessage("   .\n\n  0\n \"Vector.cpp\",  \"VectorPloskostCornerVector90\".\n         ()");return false;}
        d2/=c2; c2=1;
        d1=d1-(d2*c1); c1=0;
        //    x+b1*y=d1   z+b2*y=d2 => (b1*y-d1)^2+(b2*y-d2)^2+y^2=1  =>
        //(b1*b1+b2*b2+1)*y*y-2*(b1*d1+b2*d2)*y+(d1*d1+d2*d2-1)=0
        double a=b1*b1+b2*b2+1, k=b1*d1+b2*d2, c=d1*d1+d2*d2-1, d=k*k-a*c;
        if (d<0) {
        ShowMessage("   .\n\n    "
        +FloatToStr(d)+
        +"\n \"Vector.cpp\",  \"VectorPloskostCornerVector90\".\n");return false;}
        d=sqrt(d); b[1]=(k-d)/a; b[2]=d2-(b2*b[1]); b[0]=d1-(b1*b[1]);
        bb[1]=(k+d)/a; bb[2]=d2-(b2*bb[1]); bb[0]=d1-(b1*bb[1]);
       }
   }
return true;
}
//---------------------------------------------------------------------------
double tg(double a)//  a
{
double tmp=cos(a);
if (tmp==0) tmp=1E-20;
tmp=sin(a)/tmp;
return tmp;
}
//---------------------------------------------------------------------------
double OsFindingReal(vector reper1,vector reper2,vector reper3, float a1, float a2, float a3, vector &os)
{ //            
//         ,   
//      
//reper1, reper2, reper3 -      
//a1, a2, a3 -      
//os -     
//otkl -  
double A=reper1[0]*reper2[1]*reper3[2]+reper1[1]*reper2[2]*reper3[0]+reper1[2]*reper2[0]*reper3[1]
        -reper1[0]*reper2[2]*reper3[1]-reper1[1]*reper2[0]*reper3[2]-reper1[2]*reper2[1]*reper3[0];
double C11=reper2[1]*reper3[2]-reper2[2]*reper3[1], C12=reper1[2]*reper3[1]-reper1[1]*reper3[2],
       C13=reper1[1]*reper2[2]-reper1[2]*reper2[1],
       C21=reper2[2]*reper3[0]-reper2[0]*reper3[2], C22=reper1[0]*reper3[2]-reper1[2]*reper3[0],
       C23=reper1[2]*reper2[0]-reper1[0]*reper2[2],
       C31=reper2[0]*reper3[1]-reper2[1]*reper3[0], C32=reper1[1]*reper3[0]-reper1[0]*reper3[1],
       C33=reper1[0]*reper2[1]-reper1[1]*reper2[0];
double Cu=C11*C11+C21*C21+C31*C31,  Cv=C12*C12+C22*C22+C32*C32, Cw=C13*C13+C23*C23+C33*C33,
       Cuv=C11*C12+C21*C22+C31*C32, Cuw=C11*C13+C21*C23+C31*C33, Cvw=C12*C13+C22*C23+C32*C33;
double cosA1=cos(a1), cosA2=cos(a2), cosA3=cos(a3), sinA1=sin(a1), sinA2=sin(a2), sinA3=sin(a3);
double Qc=Cu*cosA1*cosA1+Cv*cosA2*cosA2+Cw*cosA3*cosA3+2*Cuv*cosA1*cosA2+2*Cuw*cosA1*cosA3+2*Cvw*cosA2*cosA3;
double Qcs=2*(Cu*cosA1*sinA1+Cv*cosA2*sinA2+Cw*cosA3*sinA3+Cuv*(cosA1*sinA2+cosA2*sinA1)
       +Cuw*(cosA1*sinA3+cosA3*sinA1)+Cvw*(cosA2*sinA3+cosA3*sinA2));
double Qs=Cu*sinA1*sinA1+Cv*sinA2*sinA2+Cw*sinA3*sinA3+2*Cuv*sinA1*sinA2+2*Cuw*sinA1*sinA3+2*Cvw*sinA2*sinA3;
double D=Qcs*Qcs-4*(A*A-Qc)*(A*A-Qs);
if (D>=0) D=sqrt(D);
else {ShowMessage("   .\n\n  D= "+FloatToStr(D)+
+".\n \"Vector.cpp\",  \"OsFindingReal\"."); D=0;}
double z1,z2;
if (2*(A*A-Qs)!=0)
  {z1=(Qcs-D)/(2*(A*A-Qs)),  z2=(Qcs+D)/(2*(A*A-Qs));}
else  {ShowMessage("   .\n\n   A*A-Qs= "+FloatToStr(D)+
+".\n \"Vector.cpp\",  \"OsFindingReal\".");}
double X1=atan(z1), X2=atan(z2), X0=1.5707963267948966192313216916398;
if (X1<0) X1=X1+3.1415926535897932384626433832795;
if (X2<0) X2=X2+3.1415926535897932384626433832795;

vector os0, os1, os2;
double u, v, w;  double l0;
double X=0;
double  CornerX1, CornerX2;//  

u=cos(X0-a1); v=cos(X0-a2); w=cos(X0-a3);
os0[0]=(u*C11+v*C12+w*C13)/A; os0[1]=(u*C21+v*C22+w*C23)/A; os0[2]=(u*C31+v*C32+w*C33)/A;
l0=sqrt(os0[0]*os0[0]+os0[1]*os0[1]+os0[2]*os0[2]);

if ((fabs(l0-1)<0.00000001)&&
    (fabs(CornerBetweenVectors(os0,reper1)+a1-X0)<0.000000001)&&
    (fabs(CornerBetweenVectors(os0,reper2)+a2-X0)<0.000000001)&&
    (fabs(CornerBetweenVectors(os0,reper3)+a3-X0)<0.000000001))
      {os[0]=os0[0];os[1]=os0[1];os[2]=os0[2];X=X0;};

u=cos(X1-a1); v=cos(X1-a2); w=cos(X1-a3);
os1[0]=(u*C11+v*C12+w*C13)/A; os1[1]=(u*C21+v*C22+w*C23)/A; os1[2]=(u*C31+v*C32+w*C33)/A;
CornerX1=max3(fabs(CornerBetweenVectors(os1,reper1)+a1-X1),
    fabs(CornerBetweenVectors(os1,reper2)+a2-X1),
    fabs(CornerBetweenVectors(os1,reper3)+a3-X1));
if ((fabs(CornerBetweenVectors(os1,reper1)+a1-X1)<0.000000001)&&
    (fabs(CornerBetweenVectors(os1,reper2)+a2-X1)<0.000000001)&&
    (fabs(CornerBetweenVectors(os1,reper3)+a3-X1)<0.000000001))
      {os[0]=os1[0];os[1]=os1[1];os[2]=os1[2];X=X1;};

u=cos(X2-a1); v=cos(X2-a2); w=cos(X2-a3);
os2[0]=(u*C11+v*C12+w*C13)/A; os2[1]=(u*C21+v*C22+w*C23)/A; os2[2]=(u*C31+v*C32+w*C33)/A;
CornerX2=max3(fabs(CornerBetweenVectors(os2,reper1)+a1-X2),
    fabs(CornerBetweenVectors(os2,reper2)+a2-X2),
    fabs(CornerBetweenVectors(os2,reper3)+a3-X2));
if ((fabs(CornerBetweenVectors(os2,reper1)+a1-X2)<0.000000001)&&
    (fabs(CornerBetweenVectors(os2,reper2)+a2-X2)<0.000000001)&&
    (fabs(CornerBetweenVectors(os2,reper3)+a3-X2)<0.000000001))
      {os[0]=os2[0];os[1]=os2[1];os[2]=os2[2];X=X2;};

if (X==0) {
    if (CornerX1>CornerX2){os[0]=os1[0];os[1]=os1[1];os[2]=os1[2];X=X1;}
    else {os[0]=os2[0];os[1]=os2[1];os[2]=os2[2];X=X2;}
    }

return X;
}
//---------------------------------------------------------------------------
double okrugl(double x, int tocnost)
{int t=1; for (int i=0; i<tocnost; i++) t*=10; 
int y=(int)(x*t); double delta=(double)y-(x*t);
if (delta>0.5) y=y-1;
if (delta<-0.5) y=y+1;
return (double)y/t;
}
//---------------------------------------------------------------------------
short okrugl(double x)
{short y=(short)x; double delta=(double)y-x;
if ((delta<-0.5)||(delta>0.5)) return (short)(y-1);
return y;
}
//---------------------------------------------------------------------------

